
#define _GNU_SOURCE 1
#include <stdlib.h>
#include <stdio.h>

#include <timer_q.h>

#define EXIT_FAILED_OK 77
#define FALSE 0
#define TRUE  1

#undef ASSERT
/* copy and paste from assert loop extern */
#define assert(x) do { \
 if (x) {} else { \
  fprintf(stderr, " -=> ASSERT (%s) failed in (%s) from %d %s.\n", \
          #x , __func__, __LINE__, __FILE__); \
  abort(); } \
 } while (FALSE)
#  define ASSERT(x) do { \
 if (x) {} else { \
  fprintf(stderr, " -=> ASSERT (%s) failed in (%s) from %d %s.\n", \
          #x , __func__, __LINE__, __FILE__); \
  abort(); } \
 } while (FALSE)

static int tst(void); /* fwd */


static struct Timer_q_base *t1 = NULL;
static struct Timer_q_base *t2 = NULL;
static struct Timer_q_base *t3 = NULL;
static struct Timer_q_base *t4 = NULL;

static const char *rf;

static struct Timer_q_node *tq_add(struct Timer_q_base *tx, void *data,
                                   unsigned long sec, unsigned long usec,
                                   int flags)
{
  struct timeval tv[1];
  struct Timer_q_node *ret = NULL;
  
  tv->tv_sec  = sec;
  tv->tv_usec = usec;

  ret = timer_q_add_node(tx, data, tv, flags);

  ASSERT(ret);

  return (ret);
}

static void tq_run(unsigned long sec, unsigned long usec)
{
  struct timeval tv[1];

  tv->tv_sec  = sec;
  tv->tv_usec = usec;
  timer_q_run_norm(tv);
}

#ifdef TST_CB
static void TST_CB(int, void *);
#else
static void nothing_tst_cb(int type, void *data)
{
  (void)type;
  (void)data;
  return;
}
#define TST_CB nothing_tst_cb
#endif

int main(void)
{
  int ret = 0;

  t1 = timer_q_add_base(TST_CB, TIMER_Q_FLAG_BASE_DEFAULT |
                        TIMER_Q_FLAG_BASE_RUN_ALL);
  t2 = timer_q_add_base(TST_CB, (TIMER_Q_FLAG_BASE_MALLOC_DOUBLE |
                                 TIMER_Q_FLAG_BASE_MOVE_WHEN_EMPTY |
                                 TIMER_Q_FLAG_BASE_RUN_ALL));
  t3 = timer_q_add_base(TST_CB, (TIMER_Q_FLAG_BASE_MALLOC_FUNC |
                                 TIMER_Q_FLAG_BASE_MOVE_WHEN_EMPTY |
                                 TIMER_Q_FLAG_BASE_RUN_ALL));
  t4 = timer_q_add_base(TST_CB, (TIMER_Q_FLAG_BASE_MALLOC_DOUBLE |
                                 TIMER_Q_FLAG_BASE_MALLOC_FUNC |
                                 TIMER_Q_FLAG_BASE_RUN_ALL));

  ASSERT(t1 && t2 && t3 && t4);
  
  if ((ret = tst()) && (ret != EXIT_FAILED_OK))
    fprintf(stderr, "Error(%s) value = %x\n", rf, ret);
  
  timer_q_del_base(t1);
  timer_q_del_base(t2);
  timer_q_del_base(t3);
  timer_q_quick_del_base(t4);
  
  timer_q_exit();  
  
  switch (ret)
  {
    case EXIT_FAILED_OK: exit (EXIT_FAILED_OK);
    case EXIT_SUCCESS:   exit (EXIT_SUCCESS);
    default:             exit (EXIT_FAILURE);
  }
}
