#define TST_CB tst_add_cb
#include "tst-main.c"

static const char *rf = __FILE__;

static int del_num  = 0;
static int norm_num = 0;


static Timer_q_base *tx = NULL;

static char foo[] = "0123456789xy";

static void tst_add_del(Timer_q_base *tmp_tx)
{
  Timer_q_node *n1 = tq_add(tmp_tx, foo + 10, 2, 2, TIMER_Q_FLAG_NODE_DEFAULT);
  timer_q_del_node(tmp_tx, n1);
  
  n1 = tq_add(tmp_tx, foo + 11, 2, 2, TIMER_Q_FLAG_NODE_DEFAULT);
  timer_q_quick_del_node(n1);
}

void tst_add_cb(int type, void *data)
{
  ASSERT(type != TIMER_Q_TYPE_CALL_RUN_ALL);
  
  switch (*(char *)data)
  {
    case '1': tq_add(tx, foo + 2, 1,  2, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '2': tq_add(tx, foo + 3, 1,  3, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '3': tq_add(tx, foo + 4, 1,  4, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '4': tq_add(tx, foo + 5, 1,  5, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '5': tq_add(tx, foo + 6, 1,  6, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '6': tq_add(tx, foo + 7, 1,  7, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '7': tq_add(tx, foo + 8, 1,  8, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '8': tq_add(tx, foo + 9, 1,  9, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '9': tq_add(tx, foo + 0, 1, 10, TIMER_Q_FLAG_NODE_DEFAULT); break;
    case '0': tq_add(tx, foo + 1, 2,  1, TIMER_Q_FLAG_NODE_DEFAULT); break;
      
    case '_': tst_add_del(tx); break;
      
    case 'x':
    case 'y':
      ASSERT(type == TIMER_Q_TYPE_CALL_DEL);
      ++del_num;
      return;
  }
  
  ASSERT(type == TIMER_Q_TYPE_CALL_RUN_NORM);
  ++norm_num;
}

void tst_run(void)
{
  tq_add(tx, foo + 1, 1, 1, TIMER_Q_FLAG_NODE_DEFAULT);
  
  tq_run(1, 1);
  tq_run(1, 2);
  tq_run(1, 3);
  tq_run(1, 4);
  tq_run(1, 5);
  tq_run(1, 6);
  tq_run(1, 7);
  tq_run(1, 8);
  tq_run(1, 9);

  tq_run(2, 0);

  foo[0] = '_';
  
  tq_run(2, 2); timer_q_run_all();  
}

int tst(void)
{
  tx = t1; tst_run();
  tx = t2; tst_run();
  tx = t3; tst_run();
  tx = t4; tst_run();
  
  return (EXIT_SUCCESS);
}
